: # Use perl
eval 'exec perl -S $0 "$@"'
  if $running_under_some_shell;

use strict;
use Getopt::Std;
use vars qw(%opt %wx %llx %urx @bbox @char $usage $opts $name $start $str
	    $check $wid $i $x $y $size $Y);

$opts = "hp";
$usage =<<EOD;

Usage: code39.pl [-$opts] [string]

This script converts a string, by calculating and inserting the optional
checksum character for a Code 39 message, to be printed using the Code39JK
font.

Options:
  -h  Print this help message
  -p  Generate PostScript - printed to standard output

The parameter is the message string to be converted, when absent the script
will prompt for the string.
EOD

getopts($opts, \%opt) or die "$usage\n";

die "$usage\n" if ($opt{h});

if ($#ARGV == -1) {
    print "Enter message to be converted: ";
    chop($ARGV[0]=<STDIN>);
};

undef $/;

$x = 50;
$y = 50;
$size = 40;
$name = "Code39JK";

$str = $ARGV[0];

die "Invalid character: $&\n" if ($str =~ m|[^0-9A-Z\-. \$/+%]|);

my (%val, @ch);
$i = 0;
for ('0'..'9', 'A'..'Z', '-', '.', ' ', '$', '/', '+', '%') {
    $ch[$i] = $_;
    $val{$_} = $i++;
}

$check = 0;
for (split //, $str) {
$check += $val{$_};
}
$str .= $ch[$check % 43];
$str = "*$str*";

if (!$opt{p}) {
    print "$str\n";
    exit;
}

open AFM, "../../pfa/$name.afm" or die "Cannot open font metric file\n";
$_ = <AFM>;
close AFM;
($Y) = /FontBBox.* (\d+) *$/m;
while (/C +(\d+) *; *WX +(\d+) *; *N +\S+ *; *B +(\d+) +\d+ +(\d+)/g) {
    $wx{$1} = $2;
    $llx{$1} = $3;
    $urx{$1} = $4;
}

@char = split //, $str;
$wid = $urx{ord pop @char};
for (@char) {
    $wid += $wx{ord $_};
}
@bbox = (int($x + $llx{ord $char[0]}*$size/1000), int($y),
    int($x + $wid*$size/1000 + .999), int($y + $Y*$size/1000 + .999));

$str =~ s/[)(\\]/\\$&/g;
$str =~ s/[\000-\037\177-\240]/sprintf "\\%3.3o", ord $&/eg;

open PFA, "../../pfa/$name.pfa" or die "Cannot open font file\n";
$_ = <PFA>;
close PFA;

print <<EOD;
%!PS-Adobe-3.0
%%BoundingBox: @bbox
%%Pages: 1
%%EndComments
%%BeginSetup
%%BeginResource: font $name
$_
%%EndResource
%%EndSetup

%%Page: 1 1
/$name findfont $size scalefont setfont
$x $y moveto
($str)show
showpage
%%EOF
EOD
