banner = "UPC/EAN message conversion"
msgtext = "Enter message to be converted." & vbNewLine & vbNewLine & _
  "Valid messages are:" & vbNewLine & _
  "    EAN 13:  12 digits (omit final check digit)" & vbNewLine & _
  "    EAN 8:  7 digits (omit final check digit)" & vbNewLine & _
  "    UPC A:  11 digits (omit final check digit)" & vbNewLine & _
  "    UPC E:  6 digits" & vbNewLine & vbNewLine & _
  "Each of these can optionally be followed by exactly one space " & _
  "character followed by 2 or 5 supplemental digits."

dim chars
dim val(255)
dim mess(12)
dim supp(5)
dim lmess, lsupp
dim par1(10,6)
par1(1,1) = 1
par1(1,2) = 1
par1(1,3) = 1
par1(1,4) = 1
par1(1,5) = 1
par1(1,6) = 1
par1(2,1) = 1
par1(2,2) = 1
par1(2,3) = 0
par1(2,4) = 1
par1(2,5) = 0
par1(2,6) = 0
par1(3,1) = 1
par1(3,2) = 1
par1(3,3) = 0
par1(3,4) = 0
par1(3,5) = 1
par1(3,6) = 0
par1(4,1) = 1
par1(4,2) = 1
par1(4,3) = 0
par1(4,4) = 0
par1(4,5) = 0
par1(4,6) = 1
par1(5,1) = 1
par1(5,2) = 0
par1(5,3) = 1
par1(5,4) = 1
par1(5,5) = 0
par1(5,6) = 0
par1(6,1) = 1
par1(6,2) = 0
par1(6,3) = 0
par1(6,4) = 1
par1(6,5) = 1
par1(6,6) = 0
par1(7,1) = 1
par1(7,2) = 0
par1(7,3) = 0
par1(7,4) = 0
par1(7,5) = 1
par1(7,6) = 1
par1(8,1) = 1
par1(8,2) = 0
par1(8,3) = 1
par1(8,4) = 0
par1(8,5) = 1
par1(8,6) = 0
par1(9,1) = 1
par1(9,2) = 0
par1(9,3) = 1
par1(9,4) = 0
par1(9,5) = 0
par1(9,6) = 1
par1(10,1) = 1
par1(10,2) = 0
par1(10,3) = 0
par1(10,4) = 1
par1(10,5) = 0
par1(10,6) = 1
par2 = par1
par2(1,4) = 0
par2(1,5) = 0
par2(1,6) = 0

valid = false
message = ""
prev = ""
l = 1
while l > 0
    message = getmsg
    if message > "" then
        convmess = convert
        message = inputbox("Copy the text below, and paste it into your" _
            & " application." & vbNewLine & vbNewLine _
            & "You may then enter a new message for another conversion.", _
            banner, convmess)
        valid = false
        l = len(message)
    end if
wend

function getmsg
    while not valid
        if message = "" then
            message = inputbox(msgtext, banner, prev)
        end if
        chars = mysplit(message)
        l = len(message)
        if l > 0 then
            bl = 0
            ind = 0
            valid = true
            for i = 1 to l
                if asc(chars(i)) = 32 and bl = 0 then
                    ind = i
                    bl = 1
                elseif asc(chars(i)) < 48 or asc(chars(i)) > 57 then
                    valid = false
                    exit for
                end if
            next
            if valid then
                lsupp = 0
                lmess = l
                if bl = 1 then
                    lsupp = l - ind
                    lmess = l - lsupp - 1
                end if
                if lmess = 8 or lmess = 13 then lmess = lmess - 1
                if (lmess = 6 or lmess = 7 or lmess = 11 or lmess = 12) and _
                   (lsupp = 0 or lsupp = 2 or lsupp = 5) then
                    if lmess = 11 then
                        mess(1) = 0
                        for i = 1 to 11
                            mess(i+1) = asc(chars(i)) - 48
                        next
                        lmess = 12
                    else
                        for i = 1 to lmess
                            mess(i) = asc(chars(i)) - 48
                        next
                    end if
                    for i = 1 to lsupp
                        supp(i) = asc(chars(ind+i)) - 48
                    next
                else
                    valid = false
                end if
            end if
            if not valid then
                msgbox "Invalid UPC/EAN message.", vbCritical, "Error"
                prev = message
                message = ""
            end if
        else
            valid = true
        end if
    wend
    getmsg = message
end function

function convert
    weight = 3
    if lmess = 12 then
        convert = "|"
        check = mess(1)
        for i = 2 to 12
            if i < 8 then
                char = mess(i)
                if par1(mess(1)+1,i-1) = 0 then char = chr(mess(i)+97)
            else
                char = chr(mess(i)+65)
            end if
            convert = convert & char
            check = check + weight*mess(i)
            weight = 4 - weight
            if i = 7 then convert = convert & "-"
        next
        check = 10 - check mod 10
        if check = 10 then check = 0
        comp = false
        if mess(1) = 0 and mess(5) < 3 and mess(6) = 0 and mess(7) = 0 and _
           mess(8) = 0 and mess(9) = 0 then
           slask = array(mess(3), mess(4), mess(10), mess(11), mess(12), mess(5))
           comp = true
        end if
        if mess(1) = 0 and mess(5) > 2 and mess(6) = 0 and mess(7) = 0 and _
           mess(8) = 0 and mess(9) = 0 and mess(10) = 0 then
           slask = array(mess(3), mess(4), mess(5), mess(11), mess(12), 3)
           comp = true
        end if
        if mess(1) = 0 and mess(6) > 0 and mess(7) = 0 and mess(8) = 0 and _
           mess(9) = 0 and mess(10) = 0 then
           slask = array(mess(3), mess(4), mess(5), mess(6), mess(12), 4)
           comp = true
        end if
        if mess(1) = 0 and mess(7) > 0 and mess(8) = 0 and mess(9) = 0 and _
           mess(10) = 0 and mess(11) = 0 then
           slask = array(mess(3), mess(4), mess(5), mess(6), mess(7), mess(12))
           comp = true
        end if
        if comp then
            if msgbox("This message can be represented using the more compact"_
              & " form UPC-E." & vbNewLine & "Do you want to use this?", _
              vbQuestion + vbYesNo, banner) = vbNo then
                comp = false
            end if
        end if
        if comp then
            convert = "|"
            for i = 0 to 5
                char = slask(i)
                if par2(check+1,i+1) = 1 then char = chr(slask(i)+97)
                convert = convert & char
            next
            convert = convert & "}"
        else
            convert = convert & chr(check+65) & "|"
        end if
    elseif lmess = 7 then
        convert = "|"
        check = 0
        for i = 1 to 7
            if i < 5 then
                convert = convert & mess(i)
            else
                convert = convert & chr(mess(i)+65)
            end if
            check = check + weight*mess(i)
            weight = 4 - weight
            if i = 4 then convert = convert & "-"
        next
        check = 10 - check mod 10
        if check = 10 then check = 0
        convert = convert & chr(check+65) & "|"
    elseif lmess = 6 then
        check = mess(3) + mess(5) + 3*(mess(4) + mess(6))
        if mess(6) < 3 then check = mess(4) + mess(6) + 3*(mess(3) + mess(5))
        if mess(6) = 3 then check = mess(3) + mess(4) + 3*mess(5)
        if mess(6) = 4 then check = mess(3) + mess(5) + 3*(mess(4) + mess(6))
        check = check + mess(1) + 3*mess(2)
        check = 10 - check mod 10
        if check = 10 then check = 0
        convert = "|"
        for i = 1 to 6
            char = mess(i)
            if par2(check+1,i) = 1 then char = chr(mess(i)+97)
            convert = convert & char
        next
        convert = convert & "}"
    end if
    if lsupp > 0 then
        convert = convert & " ["
        if lsupp = 2 then
            char = supp(1)
            if ((10*supp(1) + supp(2)) mod 4) > 1 then char = chr(supp(1)+97)
            convert = convert & char & ":"
            char = supp(2)
            if (supp(2) mod 2) = 1 then char = chr(supp(2)+97)
            convert = convert & char
        else
            check = 0
            weight = 3
            for i = 1 to 5
                check = check + weight*supp(i)
                weight = 12 - weight
            next
            check = check mod 10
            for i = 1 to 5
                char = supp(i)
                if par2(check+1,i+1) then char = chr(supp(i)+97)
                convert = convert & char
                if i < 5 then convert = convert & ":"
            next
        end if
    end if
end function

function mysplit(text)
    dim myarray()
    redim myarray(len(text))
    for i = 1 to len(text)
        myarray(i) = mid(text, i, 1)
    next
    mysplit = myarray
end function
